<?php
/**
* トランスフォーマを生成するファクトリクラス
*
* PHP version 5
*
* @package    core
* @author     stk2k <stk2k@sazysoft.com>
* @copyright  2008 stk2k, sazysoft
*/

class charcoal_TransformerFactory 
{
	/*
	 * トランスフォーマを作成
	 */
	public static function create( $transformer_name )
	{
		log_info( "system",  "トランスフォーマ[$transformer_name]をロードします。", __FILE__, __LINE__ );

		// Configをロード
		$config = charcoal_ConfigLoader::loadConfig( $transformer_name, "transformer" );

		// クラス名を取得
		$class_name = $config->getString( "class_name" );

		// トランスフォーマのインスタンス生成
		$transformer = charcoal_ClassUtil::newInstance( $class_name );

		// 生成したインスタンスがIValidatorインタフェースを実装しているか確認
		if ( !($transformer instanceof charcoal_ITransformer) ){
			// 実装例外
			throw new charcoal_InterfaceImplementException( $class_name, "charcoal_ITransformer" );
		}

		log_info( "system",  "トランスフォーマ[$transformer_name]を初期化します。", __FILE__, __LINE__ );

		// トランスフォーマを初期化
		$transformer->init( $config );

		log_info( "system",  "トランスフォーマ[$transformer_name]をロードしました。", __FILE__, __LINE__ );

		// ロードしたトランスフォーマを返却
		return $transformer;
	}
}
